(function () {
    "use strict";

    angular.module('core').controller('naturezaOperacaoController', controller);
    controller.$inject = ['$scope', '$timeout', 'naturezaOperacaoService', '$alert', 'lookupService','$q'];

    function controller($scope, $timeout, naturezaOperacaoService, $alert, lookupService, $q) {
        $scope.initializeLayout('Naturezas de Operação');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            vazio: false,
            count: 0,
            filtro: {
                ativo: false,
                args: {
                    chaves: '',
                    filtro: {
                        Ativo: null,
                        TipoMovimentacao: null,
                        Mercado: null, 
                    },
                    sortExpression: '',
                    skip: 0,
                    take: 20
                }
            }
        };

        $scope.popups = {
            add: {
                ativo: false,
                data: {
                    Loja: {}},
                save: function (action) {
                    $scope.state.salvando = true;
                    naturezaOperacaoService
                        .save($scope.popups.add.data)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $scope.state.salvando = false;
                                $alert({ text: response.Message, title: $scope.Title });
                            } else {
                                $scope.state.salvando = false;
                                $scope.popups.add.ativo = false;
                                $scope.popups.add.data = {};
                                $scope.initialize();
                            }
                        },
                        function (_error) {
                            $scope.state.salvando = false;
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        });
                },
                prepare: function () {
                    naturezaOperacaoService
                        .prepareNew()
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                    $scope.popups.add.ativo = false;
                                } else {
                                    $scope.popups.add.data = response.Data;
                                    $scope.popups.add.ativo = true;
                                }
                            },
                            function (_error) {
                                $scope.popups.add.ativo = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                toggle: function () {
                    $scope.popups.add.ativo = !$scope.popups.add.ativo;
                    if ($scope.popups.add.ativo) {
                        $scope.popups.add.prepare();
                    }
                },
                steps: {
                    index: 0,
                    count: 2,
                    next: function () {
                        if ($scope.popups.add.steps.index < ($scope.popups.add.steps.count - 1))
                            $scope.popups.add.steps.index++;
                    },
                    prior: function () {
                        if ($scope.popups.add.steps.index > 0)
                            $scope.popups.add.steps.index--;
                    }
                }
            }
        };


        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.getAll = function () {
            $scope.state.filtro.args.skip = 0;
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            naturezaOperacaoService
                .getAll($scope.state.filtro.args)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                        console.error(response.Exception);
                    } else {
                        angular.copy(angular.fromJson(response.Data), $scope.state.data);
                    }
                    $scope.state.carregando = false;
                    $scope.state.vazio = ($scope.state.data == 0);
                },
                function (_error) {
                    $scope.state.carregando = false;
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    console.error(_error);
                }
                );
        };
        $scope.count = function () {
            naturezaOperacaoService
                .count($scope.state.filtro.args)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                        console.error(response.Exception);
                    } else {
                        $scope.state.count = response.Data;
                    }
                },
                function (_error) {
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    console.error(_error);
                }
                );
        };
        $scope.getMore = function () {
            $scope.state.filtro.args.skip += $scope.state.filtro.args.take;
            naturezaOperacaoService
                .getAll($scope.state.filtro.args)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                        console.error(response.Exception);
                    } else {
                        $scope.state.data = $scope.state.data.concat(response.Data);
                    }
                },
                function (_error) {
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    console.error(_error);
                }
                );
        };
        $scope.refresh = function () {
            $scope.getAll();
            $scope.count();
        };

        $scope.clearFilter = function () {
            $scope.state.filtro.args.chaves = '';
            $scope.state.filtro.args.filtro.Ativo = null;
            $scope.state.filtro.args.filtro.TipoMovimentacao = null;
            $scope.state.filtro.args.filtro.Mercado = null;

            $scope.refresh();
        };
        $scope.toggleFilter = function () {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };

        $scope.auxiliar = {
            grupofiscaloperacao: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllGrupoFiscalOperacao({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            }
        };



        /*Inicializa funções*/
        $scope.initialize();

    }

})();